//=================================================================================================
// ServoGroupMove.h - Do the Group moves and the like for DeBrat
//=================================================================================================
// This part could be defined external from here... But for this pass will define the order of the items.
#ifndef _SERVOGROUPMOVE_H_
#define _SERVOGROUPMOVE_H_
#include <servo.h>

#define  NUM_GROUP_MOVE_SERVOS  7    // my current count of servos


//#ifndef NUM_GROUP_MOVE_SERVOS
//#define  NUM_GROUP_MOVE_SERVOS  32
//#endif

#define ANGLE1_TO_SERVO_PW(ang1)	((((long)(ang1) * 1666) / 1600)+1500)

// BUGBUG:: can simplify...
typedef struct _msrvoitem {
    Servo   servo;
    short    wPWTo;						// this is in milliseconds
    short    cCyclesLeft;					// number of cycles left for this move
    short    sDeltaPW;					// Delta per time unit
    short   sPWOffset;                                      // The offset for this servo...
    boolean fReverse;
} MSRVOITEM, *PMSERVOITEM;


class MServo {
  public:
    // Constructor. Set up variables.
    // Warning: currently this is limited to 32 servos...
    MServo();

    boolean  AttachServo(byte bServo, byte iPinNum, boolean fReverse);
    void     DetachServo(byte bServo);
    Servo*   GetServo(byte bServo);                            // Get the servo object associated with a pin
    void     GroupMoveStart(void);                            // Start a group move
    void     GroupMoveCommit(word wMoveTime);                 // how long in milliseconds the move should take
    boolean  ServoMoveMicroseconds(byte bServo, word wPW);    // Desired pulse width in microseconds
    boolean  ServoMoveDegrees1(byte bServo, short sDegrees1)
                    {return ServoMoveMicroseconds(bServo, ANGLE1_TO_SERVO_PW(sDegrees1)); };    // Pulse width in tenths of a Degree.

    word     ServoReadMicroseconds(byte bServo);            // Get Current Pulse width - takes care of reverse and the like.
    boolean  MoveOneServoMicroseconds(byte bServo, word wPW, word wMoveTime);
    boolean  MoveOneServoDegrees1(byte bServo, short sDegrees1, word wMoveTime)
                    {return MoveOneServoMicroseconds(bServo, ANGLE1_TO_SERVO_PW(sDegrees1), wMoveTime); };    // Pulse width in tenths of a Degree.
    
    word     WhichGroupMoveServosActive(void)    {return _uWhichServosActive; };    // returns bit mask for which servos are active.
    void     WaitForGMToComplete(unsigned uSGMMask);
    
    // functions to set and retrieve servo offsets
    boolean  SetServoOffset(byte bServo, short wOffset);
    short    GetServoOffset(byte bServo);

    void     DumpTimings(void);
//  private:
  
    void     EnableTimer(void);
    void     DisableTimer(void);
    
    // Data associated with class:
    word  	_uWhichServosActive;				// Which servos are active - bit 0 is item 0...
    word    	_servo_cycle;					// Cycle time
    word        _awNewPW[NUM_GROUP_MOVE_SERVOS];                  // cache away all of the group move requests until committed. cleanup...
    MSRVOITEM	_asrvi[NUM_GROUP_MOVE_SERVOS];			// array of servo data

    short        _cSGMCallback;				          // debug stuff...

};

// Define our one instance of the class:
extern MServo mservo;


#endif //_SERVOGROUPMOVE_H_
